﻿using System;
using System.Data;
using System.Windows.Forms;

namespace SampleApplication.BaseController
{
    public class FormBaseController<DS, DT, DR> : SampleApplication.BaseController.BaseController
		where DS : DataSet
		where DT : DataTable
		where DR : DataRow
	{
		private DS _dataSet;
		public DS DataSet
		{
			get { return _dataSet; }
			set { _dataSet = value; }
		}

		private DT _dataTable;
		public DT DataTable
		{
			get { return _dataTable; }
			set { _dataTable = value; }
		}

		private BindingSource _bindingSource;
		public BindingSource BindingSource
		{
			get { return _bindingSource; }
			set { _bindingSource = value; }
		}

        public void InitializeController(DS dataSet, DT dataTable, BindingSource bindingSource)
        {
            _dataSet = dataSet;
            _dataTable = dataTable;
            _bindingSource = bindingSource;
        }

        public FormBaseController<DataSet, DataTable, DataRow> GetBaseController()
        {
            FormBaseController<DataSet, DataTable, DataRow> baseController = new FormBaseController<DataSet, DataTable, DataRow>();
            baseController.DataSet = _dataSet;
            baseController.DataTable = _dataTable;
            baseController.BindingSource = _bindingSource;
            return baseController;
        }
    }
}
