﻿using System.Data;
using SampleApplication.Data;

namespace SampleApplication.BaseDataInterface
{
	public interface IBaseTableAdapterInterface<DT, DR, TK, SC>
		where DT : DataTable
		where DR : DataRow
		where TK : DataTableKeys
		where SC : SearchCondition
	{
		void FillTable(DT table);
		void UpdateTable(DT table);
		void FillTableByKeys(DT table, TK keys);
		TK GetKeys(DR row);
		void FillTableBySearch(DT table, SC condition);
	}
	public interface ITableAdapterInterface :
		IBaseTableAdapterInterface
		<
		DataTable,
		DataRow,
		DataTableKeys,
		SearchCondition
		>
	{
	}
}
