﻿using System.Data;
using System.Windows.Forms;

using SampleApplication.BaseController;
using SampleApplication.Data;
using SampleApplication.DataHelper;

namespace SampleApplication.UIBaseControl
{
	public partial class ListBaseControl : BaseControl
	{
		protected ListBaseController<DataSet, DataTable, DataRow> controller = new ListBaseController<DataSet,DataTable,DataRow>();

		public ListBaseControl()
		{
			InitializeComponent();
		}

        private DataGridView _dataGridView;
        public DataGridView DataGridView
        {
            get { return _dataGridView; }
            set { _dataGridView = value; }
        }

		protected virtual void InitializeControl(DataGridView grid)
		{
            _dataGridView = grid;

            RebindBindingSource();
		}

		public DataSet DataSet
		{
			get { return controller.DataSet; }
			set { controller.DataSet = value; }
		}

		public DataTable DataTable
		{
			get { return controller.DataTable; }
			set { controller.DataTable = value; }
		}

		public BindingSource BindingSource
		{
			get { return controller.BindingSource; }
			set { controller.BindingSource = value; }
		}

		public virtual void RebindBindingSource()
		{
            _dataGridView.DataSource = controller.BindingSource;
		}

		public virtual void FillTable()
		{
			controller.Fill(controller.DataTable);
		}

		public virtual DataRow GetCurrentRow()
		{
			return controller.GetCurrentRow();
		}

		public virtual DataTableKeys GetCurrentKeys()
		{
			return controller.GetCurrentKeys();
		}

		public virtual void Search(SearchCondition condition)
		{
			controller.Search(controller.DataTable, condition);
		}
	}
}
