﻿using System;
using System.Data;
using System.Windows.Forms;

using SampleApplication.Data;
using SampleApplication.UIBaseControl;
using SampleApplication.BaseController;

namespace SampleApplication.UIBaseForm
{
	public partial class FlatBaseForm : BaseForm
	{
		protected FormBaseController<DataSet, DataTable, DataRow> controller = new FormBaseController<DataSet,DataTable,DataRow>();
		private SearchBaseControl _searchControl;
		private ListBaseControl _listControl;
		private DetailBaseControl _detailControl;

		public FlatBaseForm()
		{
			InitializeComponent();
		}

		private void RebindBindingSource()
		{
            _bindingNavigator.BindingSource = controller.BindingSource;
		}

        private BindingNavigator _bindingNavigator;
        public BindingNavigator BindingNavigator
        {
            get { return _bindingNavigator; }
            set { _bindingNavigator = value; }
        }

		protected void InitializeForm(BindingNavigator bindingNavigator,
			SearchBaseControl searchControl, ListBaseControl listControl, DetailBaseControl detailControl)
		{
            _bindingNavigator = bindingNavigator;
			_searchControl = searchControl;
			_listControl = listControl;
			_detailControl = detailControl;

			RebindBindingSource();

			_listControl.DataSet = controller.DataSet;
            _listControl.DataTable = controller.DataTable;
            _listControl.BindingSource = controller.BindingSource;
			_listControl.RebindBindingSource();

			_searchControl.ClearSearchCondition();
            _listControl.FillTable();
        }

        protected void Save_Click(object sender, EventArgs e)
		{
			_detailControl.Save();
		}

        protected void AddNew_Click(object sender, EventArgs e)
		{
			_detailControl.AddNew();
		}

        protected void Delete_Click(object sender, EventArgs e)
		{
			_detailControl.Delete();
		}

        protected void Search_Click(object sender, EventArgs e)
		{
			_listControl.Search(_searchControl.GetSearchCondition());
		}
	}
}